class ReactSCSS {
    constructor() {
        this.compile = (styles, classes) => {
            return classes.map(cls => styles[cls] || cls);
        };
        this.compileEvents = (styles, events) => {
            const style = [];
            for (let event in events) {
                for (let key in events[event]) {
                    const state = events[event][key];
                    const value = events[event][state];
                    if (value) {
                        style.push(styles[value] || value);
                    }
                }
            }
            return style;
        };
        this.bind = (styles, opts = {}) => {
            const cls = opts.classes ? opts.classes.split(" ") : [];
            const dflts = opts.defaults ? opts.defaults.split(" ") : [];
            const evts = opts.events || {};
            const compiled = this.compile(styles, cls).join(" ");
            const compiledDefaults = this.compile(styles, dflts).join(" ");
            const compiledEvents = this.compileEvents(styles, evts).join(" ");
            return [compiled, compiledDefaults, compiledEvents].join(" ");
        };
    }
}
var index = new ReactSCSS();

export { index as default };
//# sourceMappingURL=index.es.js.map
