"use strict";
exports.__esModule = true;
exports.ReactSCSS = void 0;

class ReactSCSS {
    compile = (styles, classes) =>
        classes.map(cls => styles[cls] || cls).join(" ");

    compileEvents = (styles, events) =>
        Object.values(events)
            .flatMap(eventObj =>
                Object.values(eventObj).map(value => styles[value] || value)).join(" ");

    bind = (styles, opts = {}) => {
        const cls = opts.classes ? opts.classes.split(" ") : [];
        const dflts = opts.defaults ? opts.defaults.split(" ") : [];
        const evts = opts.events ? opts.events.split(" ") : [];
        const compiled = compile(styles, cls);
        const compiledDefaults = compile(styles, dflts);
        const compiledEvents = compileEvents(styles, evts);
        return [compiled, compiledDefaults, compiledEvents].join(" ");
    }
}

exports.ReactSCSS = ReactSCSS;
module.exports = new ReactSCSS();